[This is a solution to the construct the binary search tree algorithm puzzle posted earlier]
A brief description of the puzzle:
If you insert a1, then a2, then a3 and so on till an into a binary search tree, with no rebalancing etc, you get a unique tree with a1 as the root, a2 as a child of the root etc.
A naive algorithm to construct the unique tree is Ω(n2) in the worst-case.
(e.g: a1<a2<⋯<an).
Give an O(nlogn) time algorithm to construct the tree.
We will present three solutions.
Solution 1)
This solution is based on Shyam's idea.
Initially we start with (−∞,∞).
When we insert a1 this interval splits into two: (−∞,a1),(a1,∞). The left interval corresponds to the left sub-tree of a1 and the right interval corresponds to the right sub-tree of a1.
Basically, the binary search tree can be looked at as a collection of disjoint intervals, whose union is (−∞,∞) (ignoring the split points).
Each time you insert a new value into a tree, some interval is split into two, around that value.
Now we can maintain the intervals as a red-black tree whose keys are the left end points, and the values are the right endpoints, plus a pointer to a node in the target tree (target tree is the tree which we want to construct). This node in the target tree holds the value which resulted in the creation of that interval.
Given a new value which we need to insert into the target tree, say aj, we look-up the predecessor of aj in the tree of intervals (O(logn) time), and can now add the new node at the appropriate place in the target tree, in O(1) time (and update the book-keeping).
Solution 2)
This solution is based on Arvind's idea, and is perhaps essentially the same as Solution 1). It is the simplest, though.
The key observation used in this solution is the following:
When you insert x into a binary search tree, it will either be the right child of it's predecessor among the elements already present in the tree, or will be the left child of it's successor among the elements already present in the tree.
So you maintain a red-black tree along with the target tree. The nodes in the red-black tree maintain pointers to the corresponding node in the target tree, and also the when it was inserted (i.e. for aj you store j).
Now when you are inserting aj, lookup both the successor and predecessor of aj in the red-black tree.
Say we get ap and as with ap<aj<as.
Now if p<s (predecessor was inserted before), then aj will be the left left child of as in the target tree. If p>s, then aj will be the right child of ap in the target tree.
Solution 3)
This uses a lesser known data-structure called Cartesian Trees.
Given points (x1,y1),(x2,y2),…,(xn,yn)
This tree can be constructed in O(n) time (see the wiki page for details).
Suppose the sorted list of a1,…,an is b1,…,bn, with b1<b2<⋯<bn. Also, suppose bk=af(k).
Then we are looking for the Cartesian Tree corresponding to the points (b1,f(1)),(b2,f(2)),…,(bn,f(n))
We can sort ai in O(nlogn) time, and create the cartesian tree in O(n) time.
A brief description of the puzzle:
If you insert a1, then a2, then a3 and so on till an into a binary search tree, with no rebalancing etc, you get a unique tree with a1 as the root, a2 as a child of the root etc.
A naive algorithm to construct the unique tree is Ω(n2) in the worst-case.
(e.g: a1<a2<⋯<an).
Give an O(nlogn) time algorithm to construct the tree.
We will present three solutions.
Solution 1)
This solution is based on Shyam's idea.
Initially we start with (−∞,∞).
When we insert a1 this interval splits into two: (−∞,a1),(a1,∞). The left interval corresponds to the left sub-tree of a1 and the right interval corresponds to the right sub-tree of a1.
Basically, the binary search tree can be looked at as a collection of disjoint intervals, whose union is (−∞,∞) (ignoring the split points).
Each time you insert a new value into a tree, some interval is split into two, around that value.
Now we can maintain the intervals as a red-black tree whose keys are the left end points, and the values are the right endpoints, plus a pointer to a node in the target tree (target tree is the tree which we want to construct). This node in the target tree holds the value which resulted in the creation of that interval.
Given a new value which we need to insert into the target tree, say aj, we look-up the predecessor of aj in the tree of intervals (O(logn) time), and can now add the new node at the appropriate place in the target tree, in O(1) time (and update the book-keeping).
Solution 2)
This solution is based on Arvind's idea, and is perhaps essentially the same as Solution 1). It is the simplest, though.
The key observation used in this solution is the following:
When you insert x into a binary search tree, it will either be the right child of it's predecessor among the elements already present in the tree, or will be the left child of it's successor among the elements already present in the tree.
So you maintain a red-black tree along with the target tree. The nodes in the red-black tree maintain pointers to the corresponding node in the target tree, and also the when it was inserted (i.e. for aj you store j).
Now when you are inserting aj, lookup both the successor and predecessor of aj in the red-black tree.
Say we get ap and as with ap<aj<as.
Now if p<s (predecessor was inserted before), then aj will be the left left child of as in the target tree. If p>s, then aj will be the right child of ap in the target tree.
Solution 3)
This uses a lesser known data-structure called Cartesian Trees.
Given points (x1,y1),(x2,y2),…,(xn,yn)
with x1<x2<⋯<xn, a cartesian tree of these points is basically a treap (a tree + heap), with the xi forming the binary search tree values, and yi from the heap values: i.e. each node of the tree with contain an (xi,yi) pair, and when you just look at the xi, the tree will be a binary search tree, and when you just look at the yi, the tree will be a heap.
This tree can be constructed in O(n) time (see the wiki page for details).
Suppose the sorted list of a1,…,an is b1,…,bn, with b1<b2<⋯<bn. Also, suppose bk=af(k).
Then we are looking for the Cartesian Tree corresponding to the points (b1,f(1)),(b2,f(2)),…,(bn,f(n))
with the f(i) forming a min-heap.
We can sort ai in O(nlogn) time, and create the cartesian tree in O(n) time.
No comments:
Post a Comment